/*
 * ProgressDialog.java
 *
 * Created on July 20, 2001, 7:51 AM
 *
 * See LICENSE file for license conditions.
 */

package residue;

/**
 *
 * @author  chowells
 */
public class ProgressDialog extends javax.swing.JDialog
{
	
	/** Creates new form ProgressDialog */
	public ProgressDialog(java.awt.Frame parent, String label) {
		super(parent);
		initComponents();
		jLabel1.setText(label);
		pack();
		if (parent != null)
			setLocationRelativeTo(parent);
	} // ProgressDialog
	
	volatile private boolean showing = false;
	
	/**
	 * returns immediately which is not the default
	 * behavior for modal dialogs such as this.
	 */
	public void showAsync()
	{
		final Object o = this;
		new Thread(new Runnable()
		{
			public void run()
			{
				synchronized (o)
				{
					showing = true;
					o.notify();
				}
				show();
			} // run
		}).start(); // start anonymous runnable
	} // show
	
	public synchronized void waitUntilVisible()
	{
		if (!showing)
		{
			try
			{
				wait();
			}
			catch (InterruptedException e) {}
		} // if
	} // waitUntilVisible
	
	public void setMaximum(int n)
	{
		jProgressBar1.setMaximum(n);
	} // setMaximum
	
	public void setValue(int n)
	{
		jProgressBar1.setValue(n);
	} // setValue

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jPanel2 = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		jPanel1 = new javax.swing.JPanel();
		jProgressBar1 = new javax.swing.JProgressBar();
		
		setTitle("Progress");
		setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
		setModal(true);
		setResizable(false);
		addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowClosing(java.awt.event.WindowEvent evt)
			{
				closeDialog(evt);
			}
		});
		
		jPanel2.add(jLabel1);
		
		getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);
		
		jProgressBar1.setStringPainted(true);
		jPanel1.add(jProgressBar1);
		
		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
		
		pack();
	}//GEN-END:initComponents

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
    }//GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel2;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JProgressBar jProgressBar1;
	// End of variables declaration//GEN-END:variables

} // class ProgressDialog
